﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Data;

namespace XDGListCollectionViewPropChangeCase
{
    public class ViewModel
    {
        public ListCollectionView Data { get; set; }

        string[] names = "Andrew;Alex;Jen;Lisa;Devin;Mike;Rob".Split(';');

        Random r = new Random();
        public ViewModel()
        {
            ObservableCollection<SampleData> _data = new ObservableCollection<SampleData>();

            for (int i = 0; i < names.Length; i++)
            {
                SampleData sd = new SampleData() { ID = i, Name = names[i], Number = r.Next(1000) };

                ObservableCollection<ChildData> _children = new ObservableCollection<ChildData>();
                for (int j = 0; j < 4; j++)
                {                    
                    _children.Add(new ChildData() { ChildID = j, ChildNumber = r.Next(1000) });                    
                }

                sd.GridChildren = new ListCollectionView(_children);

                _data.Add(sd);
            }

            Data = new ListCollectionView(_data);
        }
    }

    public class SampleData : ObservableModel
    {
        private ListCollectionView grid_children;
        private int _id;
        private string _name;
        private int _num;  
               
        public ListCollectionView GridChildren
        {
            get { return grid_children; }
            set
            {
                if(grid_children != value)
                {
                    grid_children = value;
                    OnPropertyChanged();
                }
            }
        }        

        public int ID
        {
            get { return _id; }
            set
            {
                if(_id != value)
                {
                    _id = value;
                    OnPropertyChanged();
                }
            }
        }

        public string Name
        {
            get { return _name; }
            set
            {
                if(_name != value)
                {
                    _name = value;
                    OnPropertyChanged();
                }
            }
        }


        public int Number
        {
            get { return _num; }
            set
            {
                if(_num != value)
                {
                    _num = value;
                    OnPropertyChanged();
                }
            }
        }

    }

    public class ChildData : ObservableModel
    {
        private int c_id;
        private int c_number;
     
        public int ChildID
        {
            get { return c_id; }
            set
            {
                if(c_id != value)
                {
                    c_id = value;
                    OnPropertyChanged();
                }
            }
        }

        public int ChildNumber
        {
            get { return c_number; }
            set
            {
                if(c_number != value)
                {
                    c_number = value;
                    OnPropertyChanged();
                }
            }
        }                
    }

    public class ObservableModel : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;
        public void OnPropertyChanged([CallerMemberName] String propertyName = "")
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }

    }
}
